/*SpUpd!_2018.10.08_0000662*/
/*needVer=2018.09.05_0000661*/

CREATE OR ALTER procedure SP_PROVERKI_ONCO (
    ID_ILL integer,
    NOM_MTL smallint,
    OUT_STAC date,
    STAC_DIAG varchar(7),
    ACC1 varchar(7),
    ACC2 varchar(7),
    ACC3 varchar(7))
returns (
    OUT_IS_ONCO integer,
    OUT_ERR_STAGE smallint,
    OUT_ERR_TUMOR smallint,
    OUT_ERR_NODUS smallint,
    OUT_ERR_METAS smallint,
    OUT_ERR_DIST_METAS smallint,
    OUT_ERR_DOSE smallint,
    OUT_ERR_DECLINE smallint,
    OUT_ERR_DATE_DECLINE smallint,
    OUT_ERR_DIAGNOSTIC_TYPE smallint,
    OUT_ERR_G_SIGN smallint,
    OUT_ERR_G_TEST smallint,
    OUT_ERR_MARKER smallint,
    OUT_ERR_M_RES smallint,
    OUT_ERR_DIRECT_DATE smallint,
    OUT_ERR_DIRECT_TYPE smallint,
    OUT_ERR_METHOD smallint,
    OUT_ERR_USLUG_TO smallint)
as
declare variable P_ID_ONCO integer;
declare variable P_ID_CAUSE smallint;
declare variable P_ID_STAGE smallint;
declare variable P_ID_TUMOR smallint;
declare variable P_ID_NODUS smallint;
declare variable P_ID_METAS smallint;
declare variable P_DIST_METAS smallint;
declare variable P_DOSE numeric(3,2);
declare variable P_ID_DEC smallint;
declare variable P_DATE_DEC date;
declare variable P_DIAG_TYPE smallint;
declare variable P_ID_G_S smallint;
declare variable P_ID_G_T smallint;
declare variable P_ID_MARK smallint;
declare variable P_ID_M_R smallint;
declare variable P_G_S_CHECK smallint;
declare variable P_G_T_CHECK smallint;
declare variable P_MARK_CHECK smallint;
declare variable P_M_RES_CHECK smallint;
declare variable P_DIR_TYPE smallint;
declare variable P_METHOD smallint;
declare variable P_USLUG_TO varchar(20);
declare variable P_DATE_DIR date;
begin
OUT_ERR_STAGE = 0;
OUT_ERR_TUMOR = 0;
OUT_ERR_NODUS = 0;
OUT_ERR_METAS = 0;
OUT_ERR_DIST_METAS = 0;
OUT_ERR_DOSE = 0;
OUT_ERR_DECLINE = 0;
OUT_ERR_DATE_DECLINE = 0;
OUT_ERR_DIAGNOSTIC_TYPE = 0;
OUT_ERR_G_SIGN = 0;
OUT_ERR_G_TEST = 0;
OUT_ERR_MARKER = 0;
OUT_ERR_M_RES = 0;
OUT_ERR_DIRECT_DATE = 0;
OUT_ERR_DIRECT_TYPE = 0;
OUT_ERR_METHOD = 0;
OUT_ERR_USLUG_TO = 0;
OUT_IS_ONCO = 0;
if ((:STAC_DIAG like 'C%') or
((:STAC_DIAG = 'D70') and
((:ACC1 = 'C97') or (:ACC2 = 'C97') or (:ACC3 = 'C97') or
(substring(:ACC1 from 1 for 3) between 'C00' and 'C80') or
(substring(:ACC2 from 1 for 3) between 'C00' and 'C80') or
(substring(:ACC3 from 1 for 3) between 'C00' and 'C80')))
) then OUT_IS_ONCO = 1; -- 
if (OUT_IS_ONCO = 1) then
begin
select ONC.ID_CAUSE, ONC.ID_ONCO, ONC.ID_STAGE, ONC.ID_TUMOR, ONC.ID_NODUS, ONC.ID_METAS, ONC.DIST_METAS, ONC.DOSE
from ONCOLOGY ONC
where ONC.ID_ILL = :ID_ILL and
ONC.NOM_MTL = :NOM_MTL
into :P_ID_CAUSE, :P_ID_ONCO, :P_ID_STAGE, :P_ID_TUMOR, :P_ID_NODUS, :P_ID_METAS, :P_DIST_METAS, :P_DOSE;
-------------------------------------------
for select ODG.DIAG_TYPE, ODG.ID_G_S, ODG.ID_G_T, ODG.ID_MARK, ODG.ID_M_R
from ONCO_DIAGNOSTIC ODG
where ODG.ID_ONCO = :P_ID_ONCO
into :P_DIAG_TYPE, :P_ID_G_S, :P_ID_G_T, :P_ID_MARK, :P_ID_M_R
do
begin
if (:P_DIAG_TYPE is null) then
OUT_ERR_DIAGNOSTIC_TYPE = 1;
if (:P_DIAG_TYPE = 1) then
begin
OUT_ERR_G_SIGN = 2;
OUT_ERR_G_TEST = 2;
for
select gs.id_g_s, gt.id_g_t
from SPR_ONCO_GIST_SIGNS GS
join SPR_ONCO_SIGN_TO_DIAG SD on SD.ID_G_S = GS.ID_G_S
join SPR_ONCO_GIST_TESTS GT on GT.ID_G_S = GS.ID_G_S
where (cast(:OUT_STAC as date) between GS.DATEBEG and coalesce(GS.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between SD.DATEBEG and coalesce(SD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between GT.DATEBEG and coalesce(GT.DATEEND, '30.12.9999')) and
((:STAC_DIAG like SD.CODE_DIAG || '%') or (:ACC1 like SD.CODE_DIAG || '%') or (:ACC2 like SD.CODE_DIAG || '%') or (:ACC3 like SD.CODE_DIAG || '%'))
into :P_G_S_CHECK, P_G_T_CHECK
do
begin
if (:P_ID_G_S = :P_G_S_CHECK) then
OUT_ERR_G_SIGN = 0;
if (:P_ID_G_T = :P_G_T_CHECK) then
OUT_ERR_G_TEST = 0;
end
if (:P_ID_G_S is null) then
OUT_ERR_G_SIGN = 1;
if (:OUT_ERR_G_TEST is null) then
OUT_ERR_G_TEST = 1;
end
if (:P_DIAG_TYPE = 2) then
begin
OUT_ERR_MARKER = 2;
OUT_ERR_M_RES = 2;
for
select MK.ID_MARK, MR.ID_M_R
from SPR_ONCO_MARKERS MK
join SPR_ONCO_MARK_TO_DIAG MD on MD.ID_MARK = MK.ID_MARK
join SPR_ONCO_MARKER_RESULTS MR on MR.ID_MARK = MK.ID_MARK
where (cast(:OUT_STAC as date) between MK.DATEBEG and coalesce(MK.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MD.DATEBEG and coalesce(MD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MR.DATEBEG and coalesce(MR.DATEEND, '30.12.9999')) and
((:STAC_DIAG like MD.CODE_DIAG || '%') or (:ACC1 like MD.CODE_DIAG || '%') or (:ACC2 like MD.CODE_DIAG || '%') or (:ACC3 like MD.CODE_DIAG || '%'))
into :P_MARK_CHECK, :P_M_RES_CHECK
do
begin
if (:P_ID_MARK = :P_MARK_CHECK) then
OUT_ERR_MARKER = 0;
if (:P_ID_M_R = :P_M_RES_CHECK) then
OUT_ERR_M_RES = 0;
end
if (:P_ID_MARK is null) then
OUT_ERR_MARKER = 1;
if (:P_ID_M_R is null) then
OUT_ERR_M_RES = 1;
end
end
--------------------------------------------  ,          (  ) */
--for select ODC.ID_DEC, ODC.DATE_DEC
--    from ONCO_DECLINE ODC
--    where ODC.ID_ONCO = :P_ID_ONCO
--    into :P_ID_DEC, :P_DATE_DEC
--do
--begin
--  if (:P_ID_DEC is null) then
--    OUT_ERR_DECLINE = 1;
--  if (:P_DATE_DEC is null) then
--    OUT_ERR_DATE_DECLINE = 1;
--end
--------------------------------------------
if (not exists(select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ST.CODE_DIAG, sum(iif(:P_ID_STAGE = ST.ID_STAGE, 1, 0)) ID_IN_RANGE
      from SPR_ONCO_STAGES ST
      where ((:OUT_STAC) between ST.DATEBEG and coalesce(ST.DATEEND, '31.12.9999')) and
            (((:STAC_DIAG like ST.CODE_DIAG || '%') or (:ACC1 like ST.CODE_DIAG || '%') or (:ACC2 like ST.CODE_DIAG || '%') or (:ACC3 like ST.CODE_DIAG || '%'))
                or (ST.CODE_DIAG is null))
      group by ST.CODE_DIAG
      order by ST.CODE_DIAG desc) T)) then --     NULL
OUT_ERR_STAGE = 2;
if (:P_ID_STAGE is null) then
OUT_ERR_STAGE = 1;
--------------------------------------------
if (not exists(select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 TM.CODE_DIAG, sum(iif(:P_ID_TUMOR = TM.id_TUMOR, 1, 0)) ID_IN_RANGE
      from SPR_ONCO_TUMOR TM
      where ((:OUT_STAC) between TM.DATEBEG and coalesce(TM.DATEEND, '31.12.9999')) and
            (((:STAC_DIAG like TM.CODE_DIAG || '%') or (:ACC1 like TM.CODE_DIAG || '%') or (:ACC2 like TM.CODE_DIAG || '%') or (:ACC3 like TM.CODE_DIAG || '%'))
                or (TM.CODE_DIAG is null))
      group by TM.CODE_DIAG
      order by TM.CODE_DIAG desc) T)) then --     NULL
OUT_ERR_TUMOR = 2;
if (:P_ID_TUMOR is null) then
OUT_ERR_TUMOR = 1;
--------------------------------------------
if (not exists(select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ND.CODE_DIAG, sum(iif(:P_ID_NODUS = ND.ID_NODUS, 1, 0)) ID_IN_RANGE
      from SPR_ONCO_NODUS ND
      where ((:OUT_STAC) between ND.DATEBEG and coalesce(ND.DATEEND, '31.12.9999')) and
            (((:STAC_DIAG like ND.CODE_DIAG || '%') or (:ACC1 like ND.CODE_DIAG || '%') or (:ACC2 like ND.CODE_DIAG || '%') or (:ACC3 like ND.CODE_DIAG || '%'))
                or (ND.CODE_DIAG is null))
      group by ND.CODE_DIAG
      order by ND.CODE_DIAG desc) T)) then --     NULL
OUT_ERR_NODUS = 2;
if (:P_ID_NODUS is null) then
OUT_ERR_NODUS = 1;
--------------------------------------------
if (not exists(select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 MT.CODE_DIAG, sum(iif(:P_ID_METAS = MT.ID_METAS, 1, 0)) ID_IN_RANGE
      from SPR_ONCO_METAS MT
      where ((:OUT_STAC) between MT.DATEBEG and coalesce(MT.DATEEND, '31.12.9999')) and
            (((:STAC_DIAG like MT.CODE_DIAG || '%') or (:ACC1 like MT.CODE_DIAG || '%') or (:ACC2 like MT.CODE_DIAG || '%') or (:ACC3 like MT.CODE_DIAG || '%'))
                or (MT.CODE_DIAG is null))
      group by MT.CODE_DIAG
      order by MT.CODE_DIAG desc) T)) then --     NULL
OUT_ERR_METAS = 2;
if (:P_ID_METAS is null) then
OUT_ERR_METAS = 1;
--------------------------------------------
if ((coalesce(:P_DIST_METAS, 0) = 1) and (coalesce(P_ID_CAUSE, 0) not in (1,2))) then
OUT_ERR_DIST_METAS = 1;
--------------------------------------------
if ((exists(select * from operat o where o.id_ill = :id_ill and o.nom_mtl = :nom_mtl and o.id_u_type in (3,4))) and
(coalesce(:P_DOSE, 0) = 0)) then
OUT_ERR_DOSE = 1; --   ,      
end
for
select od.dir_type, od.method, od.uslug_to, od.date_dir from onco_direction od
where od.id_ill=:id_ill and od.nom_mtl=:nom_mtl
into :P_DIR_TYPE, :P_METHOD, :P_USLUG_TO, :P_DATE_DIR
do
begin
if (:P_DATE_DIR is null) then
OUT_ERR_DIRECT_DATE = 1;
if (:P_DIR_TYPE is null) then
OUT_ERR_DIRECT_TYPE = 1;
if (:P_DIR_TYPE = 3) then
begin
if (:P_METHOD is null) then
OUT_ERR_METHOD = 1;
if (:P_USLUG_TO is null) then
OUT_ERR_USLUG_TO = 1;
end
end
suspend;
end;
@
commit work;
@